/*
** ===================================================================
** Název souboru   : jk_xtea.h
** Mikrokontroler  : ATmega128, ATmega16,...
** Popis           : Hlavickovzy doubor k sifrovani vyuzivajici algoritmus XTEA s 128bit klicem a overenim antireplay
**                 :  
** Autor           : Jan Kristel (kristel_ml@volny,cz)
**                 : xx.04.2014
** ===================================================================
*/

#ifndef xteaH
#define xteaH

/* EEPROM ADDRESS */
#define EE_SHIFT_0          0x00       // 16bitu posunitu citace Keyshift -- pro RX desifr
#define EE_SHIFT_1          0x02 	  // pripade duplex kom. shift2       -- pro TX desifr

//--
#define EE_SHIFT_2          0x04 	  // pripade duplex kom. shift3
#define EE_SHIFT_3          0x06 	  // pripade duplex kom. shift4



/* FUNCTION */
int init_eepr();

void xtea_enc(void* dest, const void* v, const void* k);
void xtea_dec(void* dest, const void* v, const void* k);

void decode(const char* out, const char* in, const void* key);
void encode(const char* out, const char* in, const void* key, char eep_adr);

int anti_replay(char* in, char eep_adr );

#endif

